//Korean Number reader
//created by Kim Yongmook ( http://moogi.new21.org )
//Originically created on February 6, 1999
//Modified on April 21, 2005

#include <stdio.h>
#include <string.h>
#include <ctype.h>

int isvalid(char *d)
{
	int i,n=strlen(d),dot=1,neednum=0;
	if(!n) return 0; if(d[0]!='-' && !isdigit(d[0])) return 0;
	neednum=isdigit(d[0]);
	for(i=1;i<n;i++) {
		if(!isdigit(d[i]))
			if(d[i]=='.' && dot==1) dot=neednum=0; else return 0;
		else neednum=1;
	}
	return neednum;
}

typedef struct {
	char call[9]; int digitnum;
} DIGITNAME;

char id[10][3]={"","","","","","","","ĥ","",""};

#define NUMDIGIT 10

DIGITNAME unit[NUMDIGIT+1]={
	{"",28},
	{"",24},
	{"",20},
	{"",16},
	{"",12},
	{"",8},
	{"",4},
	{"õ",3},
	{"",2},
	{"",1},
	{"",0},
};

int notzero(char *p,int n)
{
	int i; for(i=0;i<n;i++) if(p[i]!='0') return 1; return 0;
}

void readnum(char *p)
{
	int i,n=strlen(p),r=n-1,o=0,z,onlyunit;
	char tmp[128];
	for(i=0;i<n;i++,r--) {
		while(unit[o].digitnum>r && o<=NUMDIGIT) o++;
		if(unit[o].digitnum==r) {
			onlyunit=p[i]=='1' && r>=1 && r<=4;
			if(p[i]=='0') continue;
			if(onlyunit) printf(unit[o].call);
			else printf("%s%s",id[p[i]-'0'],unit[o].call);
		}
		else {
			z=r-unit[o].digitnum+1;
			memset(tmp,0,z+1); strncpy(tmp,p+i,z);
			if(notzero(tmp,z)) readnum(tmp);
			i+=z-1; r=n-i-1;
			if(notzero(tmp,z)) printf(unit[o].call);
		}
	}
}

int main()
{
	char d[128],*p; int i,n;
	while(1) {
		printf("Number:"); gets(d);
		if(!isvalid(d)) { puts("Invalid number"); break; }
		if(d[0]=='-') printf("̳ʽ");
		p=strtok(d,"-.");
		if(notzero(p,strlen(p))) readnum(p); else printf(id[0]);
		if((p=strtok(0,"."))!=0) {
			printf("");
			for(i=0,n=strlen(p);i<n;i++) {
				printf(id[p[i]-'0']); if(p[i]!='0') strcpy(*id,"");
			}
		}
		puts(""); strcpy(*id,"");
	}
	return 0;
}
